<template>
  <div>
    <div v-for="element in elements" :key="element.id" class="gpa-element" :class="componentCSS(element)">
      <div class="gpa-element__title">
        <img :src="element.resource.picturePath" alt="">
        {{ element.displayName }}
      </div>
      <div class="gpa-element__actions">
        <gpa-element-actions :element="element" :context="context" />
      </div>
      <div class="gpa-element__details">
        <gpa-element-details :element="element" />
      </div>
    </div>
  </div>
</template>

<script>
import GpaElementDetails from './_Details.vue'
import GpaElementActions, { availableContexts } from './_Actions.vue'

export default {
  name: 'GpaElementsList',
  components: { GpaElementActions, GpaElementDetails },
  props: {
    elements: { required: true, type: Array },
    inline: { required: false, type: Boolean, default: false },
    context: { required: false, type: String, default: 'default', validator: v => availableContexts.includes(v) },
  },
  methods: {
    componentCSS (element) {
      return [
        this.inline && 'gpa-element--inline',
        element.isRemoved && 'gpa-element--removed',
      ]
    },
  },
}
</script>

<style src="./_List.scss" lang="scss" />
